Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ppdGrid As System.Windows.Forms.PrintPreviewDialog
    Friend WithEvents pdocGrid As System.Drawing.Printing.PrintDocument
    Friend WithEvents btnPrintPreview As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.ppdGrid = New System.Windows.Forms.PrintPreviewDialog
        Me.pdocGrid = New System.Drawing.Printing.PrintDocument
        Me.btnPrintPreview = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'ppdGrid
        '
        Me.ppdGrid.AutoScrollMargin = New System.Drawing.Size(0, 0)
        Me.ppdGrid.AutoScrollMinSize = New System.Drawing.Size(0, 0)
        Me.ppdGrid.ClientSize = New System.Drawing.Size(400, 300)
        Me.ppdGrid.Document = Me.pdocGrid
        Me.ppdGrid.Enabled = True
        Me.ppdGrid.Icon = CType(resources.GetObject("ppdGrid.Icon"), System.Drawing.Icon)
        Me.ppdGrid.Location = New System.Drawing.Point(35, 38)
        Me.ppdGrid.MinimumSize = New System.Drawing.Size(375, 250)
        Me.ppdGrid.Name = "ppdGrid"
        Me.ppdGrid.TransparencyKey = System.Drawing.Color.Empty
        Me.ppdGrid.Visible = False
        '
        'pdocGrid
        '
        '
        'btnPrintPreview
        '
        Me.btnPrintPreview.Location = New System.Drawing.Point(16, 16)
        Me.btnPrintPreview.Name = "btnPrintPreview"
        Me.btnPrintPreview.Size = New System.Drawing.Size(96, 32)
        Me.btnPrintPreview.TabIndex = 0
        Me.btnPrintPreview.Text = "Print Preview"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Controls.Add(Me.btnPrintPreview)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The index of the next row we need to print.
    Private m_NextRow As Integer

    Private Const ROW_HGT As Integer = 20
    Private Const COL_WID As Integer = 100
    Private Const NUM_ROWS As Integer = 100
    Private Const NUM_COLS As Integer = 6

    Private X_INDENT As Integer = 5
    Private Y_INDENT As Integer = 5

    ' The sample data.
    Private m_Data(,) As Integer

    ' Make some test data.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim rand As New Random

        ReDim m_Data(NUM_ROWS, NUM_COLS)
        For i As Integer = 0 To m_Data.GetUpperBound(0) - 1
            For j As Integer = 0 To m_Data.GetUpperBound(1) - 1
                m_Data(i, j) = i * 1000 + j
            Next j
        Next i

        For i As Integer = 0 To m_Data.GetUpperBound(0) - 1
            m_Data(i, 0) = i
        Next i
        For j As Integer = 0 To m_Data.GetUpperBound(1) - 1
            m_Data(0, j) = j
        Next j
    End Sub

    Private Sub btnPrintPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintPreview.Click
        ' Start with the first row and page.
        m_NextRow = 0

        ' Start the preview process.
        ppdGrid.ShowDialog()
    End Sub

    ' Print the next page of the grid.
    Private Sub pdocGrid_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pdocGrid.PrintPage
        ' Debugging: Draw the page margins.
        'Dim the_pen As New Pen(Color.Blue, 5)
        'the_pen.DashStyle = Drawing2D.DashStyle.Dash
        'e.Graphics.DrawRectangle(the_pen, e.MarginBounds)
        'the_pen.Dispose()

        ' Start at the upper margin.
        Dim y As Integer = e.MarginBounds.Top

        ' Print rows.
        For i As Integer = m_NextRow To m_Data.GetUpperBound(0) - 1
            ' Start at the left margin.
            Dim x As Integer = e.MarginBounds.Left

            ' Print columns
            For j As Integer = 0 To m_Data.GetUpperBound(1) - 1
                e.Graphics.DrawString( _
                    m_Data(i, j), _
                    Me.Font, Brushes.Black, _
                    x + X_INDENT, _
                    y + Y_INDENT)
                x += COL_WID
            Next j

            ' Move down a bit.
            y += ROW_HGT

            ' See if we're at the bottom of the page.
            If y + ROW_HGT > e.MarginBounds.Bottom Then
                ' End of the page.
                ' Draw a grid.
                DrawGrid(e, y)

                ' Move to the next row of data.
                m_NextRow = i + 1
                e.HasMorePages = (m_NextRow <= m_Data.GetUpperBound(0) - 1)
                Exit Sub
            End If
        Next i

        DrawGrid(e, y)
        e.HasMorePages = False
    End Sub

    ' Draw a grid around the page's data.
    Private Sub DrawGrid(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal y_max As Integer)
        ' Draw column lines.
        Dim x As Integer = e.MarginBounds.Left
        Dim y As Integer = e.MarginBounds.Top
        For i As Integer = 0 To m_Data.GetUpperBound(1)
            e.Graphics.DrawLine(Pens.Green, x, y, x, y_max)
            x += COL_WID
        Next i

        ' Draw row lines.
        x = e.MarginBounds.Left
        Dim xmax As Integer = x + m_Data.GetUpperBound(1) * COL_WID
        y = e.MarginBounds.Top
        Do While y <= y_max
            e.Graphics.DrawLine(Pens.Green, x, y, xmax, y)
            y += ROW_HGT
        Loop
    End Sub
End Class
